/**************************************************************************//**
 * @file     test_mailbox.c
 * @brief    CosyOS-II Ϣ
 * @detail   Ϣ䣬ʵTASK_ATASK_Bѭ
             TASK_0дڴӡÿӵļ
             ͬuRecvMail <- uSendMail
 * @author   ٿ
 * @version  V2.1.3
 * @date     2024.04.10
 ******************************************************************************/

#include "test.h"
#if TEST_OBJECT == TEST_MAILBOX

/*
 * û
 */

// ͣ0׼ԣ1ṹ/ԣ
// ׼ԣΪͣm_fetion_tø߿ɿԵѭУ飬ͨǷ
// ṹ/ԣAΪṹͣBΪͣڸʱͨǷ
#define TEST_TYPE   0

////////////////////////////////////////////////////////////////////////////////

#if TEST_TYPE == 0
typedef m_fetion_t tMail, tMail_A, tMail_B;
#else
typedef struct
{
	float m1;
	u8  m2;
	u16 m3;
	u32 m4;
	s8  m5;
	s16 m6;
	s32 m7;
	double m8;
}tMail_A;
typedef s32 tMail_B[8];
static const tMail_A mailbox_A = {3.1415926, 0x0F, 0x0F0F, 0x0F0F0F0F, 0xE0, 0xE0E0, 0xE0E0E0E0, -6295141.3};
static const tMail_B mailbox_B = {0xA0, 0xA0A0, 0xA0A0A0A0, 0x0B, 0x0B0B, 0x0B0B0B0B, 2147483647, 655363636};
#endif

/* Ϣ */
uExternMailbox(MAILBOX_A, tMail_A);
uCreateMailbox(MAILBOX_A);
uExternMailbox(MAILBOX_B, tMail_B);
uCreateMailbox(MAILBOX_B);

/*  */
void start_hook(void)
{
	uStartTask(TASK_0, 0); //  TASK_0
	uStartTask(TASK_A, 0); //  TASK_A
	uStartTask(TASK_B, 0); //  TASK_B
	printf("TASK_A | TASK_A - TASK_B | error message\r\n\r\n"); // ӡ
	/* ԣȷʼMAILBOX_A */
	{
		#if TEST_TYPE == 0
		static const tMail mailbox_s = 1;
		uSendMail(MAILBOX_A, (void *)&mailbox_s);
		#else
		uSendMail(MAILBOX_A, (void *)&mailbox_A);
		#endif
	}
}

/*  TASK_A */
uCreateTask(TASK_A, TEST_TASKPRI_MID, TEST_TASKSTACKSIZE, 0, 0)
{
	#if TEST_TYPE == 0
	tMail mailbox_r = 0;
	static tMail mailbox_s = 0;
	mailbox_s++;
	if(uRecvMail(&mailbox_r, MAILBOX_A, ~0) && mailbox_r == mailbox_s){
		mailbox_s++;
		vCounter_A++;
		uSendMail(MAILBOX_B, &mailbox_s);
	}
	else{
		vError = true;
	}
	#else
	tMail_A mailbox_r = {0,0,0,0,0,0,0,0};
	if(uRecvMail(&mailbox_r, MAILBOX_A, ~0) && !memcmp(&mailbox_r, (void *)&mailbox_A, sizeof(tMail_A))){
		vCounter_A++;
		uSendMail(MAILBOX_B, (void *)&mailbox_B);
	}
	else{
		vError = true;
	}
	#endif
	uEndTasking;
}

/*  TASK_B */
uCreateTask(TASK_B, TEST_TASKPRI_LOW, TEST_TASKSTACKSIZE, 0, 0)
{
	#if TEST_TYPE == 0
	tMail mailbox_r = 0;
	static tMail mailbox_s = 1;
	mailbox_s++;
	if(uRecvMail(&mailbox_r, MAILBOX_B, ~0) && mailbox_r == mailbox_s){
		mailbox_s++;
		vCounter_B++;
		uSendMail(MAILBOX_A, &mailbox_s);
	}
	else{
		vError = true;
	}
	#else
	tMail_B mailbox_r = {0,0,0,0,0,0,0,0};
	if(uRecvMail(&mailbox_r, MAILBOX_B, ~0) && !memcmp(&mailbox_r, (void *)&mailbox_B, sizeof(tMail_B))){
		vCounter_B++;
		uSendMail(MAILBOX_A, (void *)&mailbox_A);
	}
	else{
		vError = true;
	}
	#endif
	uEndTasking;
}



#endif
